package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import javafx.beans.property.SimpleStringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.geometry.Rectangle2D;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.layout.VBox;
import javafx.stage.Screen;

import java.net.URL;
import java.util.ResourceBundle;

public class CommunityMapController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private TableView<DataItem> tableView;
    @FXML
    private TableColumn<DataItem, String> name;

    Rectangle2D screen = Screen.getPrimary().getVisualBounds();

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        tableView.setOnMouseClicked(mouseEvent -> System.out.println(tableView.getWidth()));
        setTableView();
    }

    private void setTableView() {
        tableView.setMinHeight(screen.getHeight() * 0.69);
        tableView.setMinWidth(screen.getWidth() * 0.66);

        name.setCellValueFactory(new PropertyValueFactory<>("name"));
        ObservableList<DataItem> data = FXCollections.observableArrayList(
                new DataItem("Item A"),
                new DataItem("Item B"),
                new DataItem("Item C")
        );

        tableView.setItems(data);
    }

//    TODO: create map preview

    @FXML
    private void backButton() {
        parent.getChildren().clear();
        parent.getChildren().add(new SceneLoader().loadScene("MapForge"));
    }

//    test values TODO: replace with db
    public static class DataItem {
        private final SimpleStringProperty name;

        public DataItem(String name) {
            this.name = new SimpleStringProperty(name);
        }

        public String getName() {
            return name.get();
        }

        public SimpleStringProperty nameProperty() {
            return name;
        }
    }
}
