package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.AccountType;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadStartup2 extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadStartup2.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        Threads threadsInstance = Threads.getInstance();

        try {
            threadsInstance.setThreadStartup2Msg("");
            threadsInstance.setThreadStartup2(ThreadStatus.RUNNING);
            persistenceInst.loadPlayerAccount();
            if(persistenceInst.getAccount().getAccountType() != AccountType.NONE){
                persistenceInst.verifyPlayerAccount();
            }
            log.info("Startup routine part2 complete!");
            threadsInstance.setThreadStartup2(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            threadsInstance.setThreadStartup2Msg(e.getMessage());
            log.info("Startup routine part2 failed!");
            threadsInstance.setThreadStartup2(ThreadStatus.FAILED);
        }
    }

}
