package de.hdm_stuttgart.battlearena.Model.Multiplayer;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.IOException;
import java.util.Arrays;
import java.util.concurrent.TimeUnit;

public class ConnectionHandler {

    private static int pX = 0;
    private static int pY = 0;
    private static int enemyX = 0;
    private static int enemyY = 0;
    private static int playerID = 0;
    private static int[] coordinates = {pX,pY,playerID};
    private static String ipaddress = "localhost";
    private static final Logger log = LogManager.getLogger(ConnectionHandler.class);

    public void startHandler() throws IOException, InterruptedException {

        Client client = new Client();
        client.startConnection(ipaddress, 4444);

        ConnectionThread connectionthread = new ConnectionThread(client);
        connectionthread.start();

    }

    private static class ConnectionThread extends Thread {
        private final Client client;

        public ConnectionThread(Client client) {
            this.client = client;
        }

        public void run() {
            try {
                while (!Thread.interrupted()) {
                    int[] cords = client.sendcords(coordinates);
                    enemyX = cords[0];
                    enemyY = cords[1];
                //    System.out.println("Enemy X: " + enemyX);
                //    System.out.println("Enemy Y: " + enemyY);
                //    System.out.println("Your PlayerID is " + cords[2]);
                    playerID = cords[2];
                    // Assign the Values to the message to send:
                    coordinates[0] = pX;
                    coordinates[1] = pY;
                    coordinates[2] = playerID;

                    Thread.sleep(16);
                }
            } catch (InterruptedException | IOException e) {
                e.printStackTrace(); // Handle the exception as needed
            }
        }
    }

    public int getPlayerID() {
        return playerID;
    }

    public int getpX() {
        return pX;
    }

    public void setpX(int pX) {
        this.pX = pX;
    }

    public int getpY() {
        return pY;
    }

    public void setpY(int pY) {
        this.pY = pY;
    }

    public int getEnemyX() {
        return enemyX;
    }
    public int getEnemyY() {
        return enemyY;
    }

    public static void setIpaddress(String ipaddress) {
        ConnectionHandler.ipaddress = ipaddress;
    }
}

